import $http from '../index'
import { API_TYPE } from '@/utils/constants'
// 随访方案查询
export function queryFollowSchemeApi (data) {
  return $http({
    url: '/crfFollowScheme/queryFollowScheme',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 查询单个随访方案
export function querySchemeOneApi (data) {
  return $http({
    url: '/crfFollowScheme/querySchemeOne',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 查询随访方案所有版本
export function queryVersionApi (data) {
  return $http({
    url: '/crfFollowScheme/queryVersions',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 方案名称重复判定
export function verifyRepetitionApi (data) {
  return $http({
    url: '/crfFollowScheme/verifyRepetition',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data,
    loading: false
  })
}
// 新增随访方案
export function addFollowSchemeApi (data) {
  return $http({
    url: '/crfFollowScheme/addFollowScheme',
    method: 'post',
    api: API_TYPE.saascrf,
    data: data
  })
}
// 复制随访方案
export function copyFollowSchemeApi (data) {
  return $http({
    url: '/crfFollowScheme/copyFollowScheme',
    method: 'post',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 修改随访方案状态
export function updateFollowSchemeStatusApi (data) {
  return $http({
    url: '/crfFollowScheme/updateFollowSchemeStatus',
    method: 'put',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 修改随访方案
export function updateFollowSchemeApi (data) {
  return $http({
    url: '/crfFollowScheme/updateFollowScheme',
    method: 'put',
    api: API_TYPE.saascrf,
    data: data
  })
}
// 删除随访方案
export function deleteFollowSchemeApi (data) {
  return $http({
    url: '/crfFollowScheme/deleteFollowScheme',
    method: 'delete',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 查询随访计划时间轴
export function queryFollowPlanApi (data) {
  return $http({
    url: '/crfFollowPlan/queryFollowPlan',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 删除随访计划
export function deleteFollowPlanApi (data) {
  return $http({
    url: '/crfFollowPlan/deleteFollowPlan',
    method: 'delete',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 新增随访计划
export function addFollowPlanApi (data1, data2) {
  return $http({
    url: '/crfFollowPlan/addFollowPlan',
    method: 'post',
    api: API_TYPE.saascrf,
    data: data1,
    params: data2
  })
}
// 计划名称重复判定
export function verifyRepetitionPlanApi (data) {
  return $http({
    url: '/crfFollowPlan/verifyRepetitionPlan',
    method: 'get',
    params: data,
    api: API_TYPE.saascrf,
    loading: false
  })
}
// 随访计划--保存为新版本
export function addFollowPlanVersionsApi (data) {
  return $http({
    url: '/crfFollowPlan/addFollowPlanVersions',
    method: 'post',
    api: API_TYPE.saascrf,
    data: data
  })
}
// 复制随访计划
export function copyFollowPlanApi (data) {
  return $http({
    url: '/crfFollowPlan/copyFollowPlan',
    method: 'post',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 查询单个随访计划
export function queryPlanOneApi (data) {
  return $http({
    url: '/crfFollowPlan/queryPlanOne',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 修改随访计划
export function updateFollowPlanApi (data) {
  return $http({
    url: '/crfFollowPlan/updateFollowPlan',
    method: 'put',
    api: API_TYPE.saascrf,
    data: data
  })
}
// 查询所有项目信息
export function queryItemListApi (data) {
  return $http({
    url: '/crfFollowScheme/queryItemList',
    method: 'get',
    api: API_TYPE.saascrf,
    params: data
  })
}
// 方案简称重复判定
export function verifyRepetitionAbbreviationApi (data) {
  return $http({
    url: '/crfFollowScheme/verifyRepetitionAbbreviation',
    method: 'get',
    params: data,
    api: API_TYPE.saascrf,
    loading: false
  })
}
