import $http from '@/api/index'

// crf的接口
// 保存分类信息
export function addClassify(data) {
  return $http({
    url: '/crfElementClassify/addClassify',
    method: 'post',
    data: data
  })
}
// 验证分类名称是否重复以及是否可删除
export function verifyLabelName(data) {
  return $http({
    url: '/crfElementClassify/verifyLabelName',
    method: 'put',
    params: data,
    loading: false,
    tips: false
  })
}
// 删除分类信息
export function delClassify(data) {
  return $http({
    url: '/crfElementClassify/delClassify',
    method: 'delete',
    params: data
  })
}
// 根据分类代码查询单个列表
export function getClassifyList(data) {
  return $http({
    url: '/crfElementClassify/getClassifyList',
    method: 'get',
    params: data
  })
}
// 根据分类代码查询单个列表(启用状态)
export function getClassifyListStatus(data) {
  return $http({
    url: '/crfElementClassify/getClassifyListStatus',
    method: 'get',
    params: data
  })
}
// 根据分类名称或者元素名称查询单个分类或者元素
export function getClassifyListByInput(data) {
  return $http({
    url: '/crfElementClassify/getClassifyListByInput',
    method: 'get',
    params: data
  })
}
// 根据分类名称或者元素名称查询单个分类或者元素(启用状态)
export function getClassifyListByInputStatus(data) {
  return $http({
    url: '/crfElementClassify/getClassifyListByInputStatus',
    method: 'get',
    params: data
  })
}
// 查询元素分类树状结构(两级)
export function listClassifyTree(data) {
  return $http({
    url: '/crfElementClassify/listClassifyTree',
    method: 'get',
    params: data
  })
}
// 查询表单库下的元素分类树状结构(两级)
export function listActiveClassifyTree(data) {
  return $http({
    url: '/saascrf/crfElementClassify/listActiveClassifyTree',
    method: 'get',
    params: data
  })
}
// 修改分类信息
export function updClassify(data) {
  return $http({
    url: '/crfElementClassify/updClassify',
    method: 'put',
    data: data
  })
}

// 保存元素信息
export function addElement(data) {
  return $http({
    url: '/crfElementInfo/addElement',
    method: 'post',
    data: data
  })
}
// 验证元素名称是否重复以及是否可删除
export function verifyElementName(data) {
  return $http({
    url: '/crfElementClassify/verifyElementName',
    method: 'put',
    params: data,
    loading: false,
    tips: false
  })
}
// 删除元素信息
export function delElement(data) {
  return $http({
    url: '/crfElementInfo/delElement',
    method: 'delete',
    params: data
  })
}
// 查询单个元素信息
export function getElementInfo(data) {
  return $http({
    url: '/crfElementInfo/getElementInfo',
    method: 'get',
    params: data
  })
}
// 修改元素信息
export function updElement(data) {
  return $http({
    url: '/crfElementInfo/updElement',
    method: 'put',
    data: data
  })
}
// 修改停用状态
export function updStatus(data) {
  return $http({
    url: '/crfElementInfo/updStatus',
    method: 'put',
    params: data
  })
}
