import $http from '@/api/index'

// 获取结构化数据库树
export function getStructuredDatabaseTreeApi() {
  return $http({
    url: '/emr/getTElementList',
    method: 'get'
  })
}
// 删除段落
export function deleteParagraphApi(data) {
  return $http({
    url: '/paragraph/delTEmrParagraph',
    method: 'post',
    params: data
  })
}
// 添加段落
export function addParagraphApi(data) {
  return $http({
    url: '/paragraph/addTEmrParagraph',
    method: 'post',
    data: data
  })
}
// 修改段落
export function modifyParagraphApi(data) {
  return $http({
    url: '/paragraph/updateTEmrParagraph',
    method: 'post',
    data: data
  })
}
// 添加章节
export function addChapterApi(data) {
  return $http({
    url: '/chapter/addTEmrChapter',
    method: 'post',
    data: data
  })
}
// 修改章节
export function editChapterApi(data) {
  return $http({
    url: '/chapter/updateTEmrChapter',
    method: 'post',
    data: data
  })
}
// 删除章节
export function deleteChapterApi(data) {
  return $http({
    url: '/chapter/delTEmrChapter',
    method: 'post',
    params: data
  })
}
// 获取章节和对应的段落树
export function getChapterAndParagraphApi(data) {
  return $http({
    url: '/chapter/selAllTEmrChapter',
    method: 'get',
    params: data
  })
}
// 查询所有章节
export function getAllChaptersApi(data) {
  return $http({
    url: '/paragraph/selAllParagraph',
    method: 'get',
    params: data
  })
}
// 查询单条章节和对应的段落信息
export function getSingleChapterApi(data) {
  return $http({
    url: '/chapter/selTEmrChapter',
    method: 'get',
    params: data,
    loading: false
  })
}
// 查询单条段落信息
export function getSingleParaphterApi(data) {
  return $http({
    url: '/paragraph/selOneTEmrParagraph',
    method: 'get',
    params: data,
    loading: false
  })
}
// 查询所有科室
// export function getAllDepartmentApi() {
//   return $http({
//     url: '/paragraph/selAllTCodeDepartmentInformation',
//     method: 'get'
//   })
// }
export function getAllDepartmentApi() {
  return $http({
    url: '/paragraph/selAllTCodeDepartmentInformation',
    method: 'get'
  })
}
// 查询是否有重复段落名称
export function paragraphSelRepeat(data) {
  return $http({
    url: '/paragraph/selRepeat',
    method: 'get',
    params: data,
    loading: false,
    tips: false
  })
}
// 查询是否有重复章节名称
export function chapterSelRepeat(data) {
  return $http({
    url: '/chapter/selRepeat',
    method: 'get',
    params: data,
    loading: false,
    tips: false
  })
}
