function isObj(object) {
  return object && typeof(object) == 'object' && Object.prototype.toString.call(object).toLowerCase() == "[object object]";
}

function isArray(object) {
  return object && typeof(object) == 'object' && object.constructor == Array;
}

function getLength(object) {
  var count = 0;
  for(var i in object) count++;
  return count;
}

export function CompareJsonObj(objA, objB) {
  if(!isObj(objA) || !isObj(objB)) return false; //判断类型是否正确
  if(getLength(objA) != getLength(objB)) return false; //判断长度是否一致
  return CompareObj(objA, objB, true); //默认为true
}

function CompareObj(objA, objB, flag) {
if(getLength(objA) != getLength(objB)) return false;
  for(var key in objA) {
      if(!flag) //flag为false，则跳出整个循环
          break;
      if(!objB.hasOwnProperty(key)) {//是否有自身属性，而不是继承的属性
          flag = false;
          break;
      }
      if(!isArray(objA[key])) { //子级不是数组时,比较属性值        	
        if (isObj(objA[key])) {
          if (isObj(objB[key])) {
            if(!flag) //这里跳出循环是为了不让递归继续
                      break;
            flag = CompareObj(objA[key], objB[key], flag);
          } else {
            flag = false;
                  break;
          }
        } else {
          if(String(objB[key]) != String(objA[key])) { //排除数字比较的类型差异
              flag = false;
                  break;
              }
        }
      } else {
          if(!isArray(objB[key])) {
              flag = false;
              break;
          }
          var oA = objA[key],
              oB = objB[key];
          if(oA.length != oB.length) {
              flag = false;
              break;
          }
          for(var k in oA) {
              if(!flag) //这里跳出循环是为了不让递归继续
                  break;
              flag = CompareObj(oA[k], oB[k], flag);
          }
      }
  }
  return flag;
}
/**
 * 创建时的路由识别
 */
export const CREATE_ACTION = 'create'
/**
 * 创建时的路由识别
 */
export const EDIT_ACTION = 'edit'
/**
 * 表单graphQL数据源名称
 */
export const FORM_CLIENT = 'smartform'
/**
 * 表单graphQL数据源名称
 */
export const COMMON_CLIENT = 'common'
/**
 * 表单graphQL数据源名称，无loading
 */
export const FORM_CLIENT_UNLOADING = 'smartform'
/**
 * 七牛上传路径
 */
// export const UPLOAD_URL = process.env.VUE_APP_OSS_UPLOAD_URL
export const UPLOAD_URL = ''
/**
 * 七牛下载路径
 */
// export const DOWNLOAD_URL = process.env.VUE_APP_OSS_BASE_URL
export const DOWNLOAD_URL = ''
/**
 * apollo错误类型
 */
export const APOLLO_ERROR = {
  // 位置报错
  unknowError: '60401',
  // 业务错误
  businessError: '60402'
}
/**
 * 表单模块所有默认分页数量设置
 */
export const PAGE_CONFIG = {
  sizes: [10, 25, 50, 100],
  nowSize: 10
}
/**
 * 分类查询类型
 */
export const CATEGORY_TYPE = {
  /**
   * 表单
   */
  smartform: 1,
  /**
   * 定制组件
   */
  group: 2
}
/**
 * 分页中的字段类型
 */
export const PAGE_FIELD_TYPE = {
  /**
   * 控件类型
   */
  widget: 1,
  /**
   * 组
   */
  group: 2,
  /**
   * 分页
   */
  page: 3
}
/**
 * 组的类型
 */
export const GROUP_TYPE = {
  /**
   * 超级组
   */
  super: 1,
  /**
   * 样式组
   */
  style: 2,
  /**
   * 表格组/可复制组
   */
  table: 3
}
/**
 * 表格组的行类型
 */
export const GROUP_LINE_TYPE = {
  /**
   * 普通行
   */
  common: 1,
  /**
   * 合计行
   */
  total: 2
}
/**
 * 表单基本控件类型
 */
export const FIELD_TYPE = {
  /**
   * 数字文本
   */
  number: 1,
  /**
   * 文本框
   */
  input: 2,
  /**
   * 多行文本
   */
  textarea: 3,
  /**
   * 富文本
   */
  editor: 4,
  /**
   * 单选框
   */
  radio: 5,
  /**
   * 复选框
   */
  checkbox: 6,
  /**
   * 下拉菜单
   */
  select: 7,
  /**
   * 多级下拉
   */
  cascader: 8,
  /**
   * 日期
   */
  date: 9,
  /**
   * 日期间隔
   */
  dateSpan: 10,
  /**
   * 时间
   */
  time: 11,
  /**
   * 时间间隔
   */
  timeSpan: 12,
  /**
   * 上传
   */
  upload: 13,
  /**
   * 文本描述
   */
  label: 14,
  /**
   * 数字范围间隔
   */
  numRangeSpan: 15,
  /***
   * 复选框其他
   */
  checkboxOther: 16,
  /***
   * 单选框其他
   */
  radioOther: 17,
  /**
   * 文本范围间隔
   */
  rangeSpan: 19
}
/**
 * 规则类型 1.必填，2.长度，3.正则，4.符号，5.小数，6.数字大小
 */
export const RULE_TYPE = {
  /**
   * 必填
   */
  required: 1,
  /**
   * 长度
   */
  lenght: 2,
  /**
   * 正则
   */
  regexp: 3,
  /**
   * 符号
   */
  symbol: 4,
  /**
   * 小数
   */
  decimal: 5,
  /**
   * 数字大小
   */
  size: 6,
  // 自定义规则
  custom: 7
}
/**
 * 表单状态
 */
export const FORM_TYPE = {
  /**
   * 全部状态
   */
  all: 10,
  /**
   * 新建模式
   */
  dev: 1,
  /**
   * 发布模式
   */
  release: 2
}
/**
 * 表单内容状态
 */
export const FORM_CONTENT_TYPE = {
  // 全部状态
  all: 10,
  // 删除状态
  del: 0,
  // 暂存
  storage: 1,
  // 提交中
  committing: 2,
  // 已提交
  submit: 3,
  // 退回
  refuse: 4,
  // 退回时已提交状态，该状态下可以再次提交退回的表单
  refuseSubmit: 5
}
/**
 * 控件数据状态
 */
export const WIDGET_STATE = {
  /**
   * 删除
   */
  del: 0,
  /**
   * 基本控件
   */
  base: 1,
  /**
   * 预设控件
   */
  custom: 2,
  /**
   * 表单引用的控件
   */
  form: 3,
  /**
   * 规则用的设置
   */
  rule: 4
}
/**
 * 提交业务的sql类型，1: 组件（单行）；2: 表格 (多行)；3：上传控件
 */
export const SQLDATA_TYPE = {
  component: 1,
  table: 2,
  upload: 3
}
/**
 * 后缀类型
 */
export const SUFFIX_TYPE = {
  /**
   * 文本
   */
  text: 1,
  /**
   * URL
   */
  url: 2
}
export const DATE_TYPE = {
  /**
   * 年
   */
  year: 1,
  /**
   * 月
   */
  month: 2,
  /**
   * 周
   */
  week: 3,
  /**
   * 日期
   */
  date: 4,
  /**
   * 日期+时间
   */
  dateTime: 5
}
/**
 * 时间类型
 */
export const TIME_TYPE = {
  /**
   * 步长模式
   */
  step: 1,
  /**
   * 自由模式
   */
  free: 2
}
/**
 * 配置权限等级
 */
export const USE_POWER = {
  /**
   * 权限
   */
  authLevelZero: 0,
  /**
   * 权限一
   */
  authLevelOne: 1,
  /**
   * 权限二
   */
  authLevelTwo: 2

}
/**
 * 限定当前模式
 */
export const LIMIT_DATE_TYPE = {
  // 未设置
  none: 0,
  // 开始当前时间
  start: 1,
  // 结束当前时间
  end: 2
}
/**
 * 符号规则,0.正负,1.正,2.负
 */
export const SYMBOL_TYPE = {
  symbol: 0,
  plus: 1,
  minus: 2
}
/**
 * 映射类型：1，参数；2，字段别名（表名.别名）；3，组件状态关系表；4，上传列表
 */
export const FMAPPER_TYPE = {
  param: 1,
  alias: 2,
  stateTable: 3,
  uploadTable: 4,
  endDate: 5
}
/**
 * 对应字段的数据类型：1，字符串；2，Long(日期)
 */
export const FMAPPER_DATA_TYPE = {
  string: 1,
  long: 2
}
/**
 * label分割线 1，上分割线；2，下分割线；3，上下都有（默认）
 */
export const LABEL_SPLIT_TYPE = {
  top: 1,
  bottom: 2,
  both: 3
}
/**
 * label分割线选项
 */
export const LABEL_SPLIT_TYPEOPTION = [{
  id: LABEL_SPLIT_TYPE.top,
  name: '上分割线'
}, {
  id: LABEL_SPLIT_TYPE.bottom,
  name: '下分割线'
}, {
  id: LABEL_SPLIT_TYPE.both,
  name: '上下分割线'
}]
/**
 * 分页模式：1，页顶tab；2，左侧tab
 */
export const PAGEMODE_TYPE = {
  top: 1,
  left: 2
}
/**
 * 控件基本属性
 */
export const WIDGET = {
  authLevel: 0,
  des: '',
  placeholder: '',
  hide: false,
  disable: false,
  // 数据字段别名
  alias: '',
  // 结束日期/时间字段别名
  endAlias: '',
  rules: [],
  isSelect: false,
  // 是否可以设置，如果false则该控件的设置不可改动
  setting: true,
  // lab宽度
  labWidth: '15%',
  // 整体宽度
  colSpan: 24,
  // 是否显示title
  showTitle: true
}
/**
 * 日期基本属性
 */
const DATE_PROPS = {
  dateType: DATE_TYPE.date, // 日期类型
  clear: true, // 是否可清除
  link: false,
  defStartToday: false,
  defEndToday: false,
  defStartDate: null,
  defEndDate: null,
  limitStartDate: null,
  limitEndDate: null,
  limitToday: LIMIT_DATE_TYPE.none,
  startPlace: '开始时间',
  endPlace: '结束时间'
}
/**
 * 时间基本属性
 */
const TIME_PROPS = {
  timeType: TIME_TYPE.free,
  clear: true,
  timeStart: '00:00', // 开始时间
  timeEnd: '24:00', // 结束时间
  timeStep: '00:05', // 步长
  defStartTime: null,
  defEndTime: null,
  limitStart: false, // 是否限制开始时间
  limitEnd: false, // 是否限制结束时间
  limitStartTime: null, // 限制起始时间
  limitEndTime: null, // 限制结束时间
  limitNow: LIMIT_DATE_TYPE.none,
  optionalMode: false,
  startPlace: '开始时间',
  endPlace: '结束时间'
}

/**
 *  组-行
 */
export const GROUP_LINE = {
  // 行类型 1.普通行，2.合计行
  lineType: 1,
  // 行号
  lineNum: 1,
  // 列字段列表,存储字段ID，没有的为''
  columnNum: '',
  // 组内字段列表
  fieldList: [],
  // 是否是用户拷贝行
  isClone: false
}
/**
 *  规则基本属性
 */
export const RULE_PROPS = {
  enable: false,
  trigger: '["blur"]',
  message: null
}
/**
 *  必填规则
 */
export const RULE_REQUIRED = {
  ...RULE_PROPS,
  type: RULE_TYPE.required,
  defMessage: '此项为必填项',
  required: false,
  whitespace: true
}

/**
 *  长度验证
 */
export const RULE_LENGHT = {
  ...RULE_PROPS,
  type: RULE_TYPE.lenght,
  defMessage: '',
  minLenght: 0,
  maxLenght: 0
}
/**
 *  正则规则
 */
export const RULE_REGEXP = {
  ...RULE_PROPS,
  type: RULE_TYPE.regexp,
  defMessage: '',
  regexpID: 1,
  regexp: ''
}
/**
 *  符号规则
 */
export const RULE_SYMBOL = {
  ...RULE_PROPS,
  type: RULE_TYPE.symbol,
  plusMinus: SYMBOL_TYPE.plus,
  defMessage: ''
}
/**
 *  小数规则，如果decimal=false，在输入小数时直接去掉，不提示
 */
export const RULE_DECIMAL = {
  ...RULE_PROPS,
  type: RULE_TYPE.decimal,
  decimalLenght: 0,
  defMessage: ''
}
/**
 *  数字范围验证
 */
export const RULE_SIZE = {
  ...RULE_PROPS,
  type: RULE_TYPE.size,
  defMessage: '',
  minValue: 0,
  maxValue: 20
}
/**
 *  自定义规则,可以多条
 */
export const RULE_CUSTOM = {
  ...RULE_PROPS,
  type: RULE_TYPE.custom,
  id: 1,
  ruleName: '自定义规则',
  // 条件判定规则列表，条件满足才进行结果判定，空则直接运行结果
  conditionList: [],
  // 结果判定规则列表，结果为false，进行错误提示
  resultList: []
}
/**
 *  条件规则
 */
export const RULE_CONDITION = {
  // 条件类型，1，条件；2，逻辑运算符
  type: '',
  // 公式运算单元列表
  operatorList: [],
  // 逻辑运算符
  logicOperator: ''
}
/**
 *  条件规则类型
 */
export const RULE_CONDITION_TYPE = {
  // 条件类型，1，公式；2，逻辑运算符
  formula: 1,
  logic: 2
}
/**
 * 后缀提示初始值
 */
export const SUFFIX_INIT = {
  suffixOptions: [{
    value: SUFFIX_TYPE.text,
    label: '文本'
  }, {
    value: SUFFIX_TYPE.url,
    label: 'URL'
  }]
}
/*
 * 权限选项初始值
 */
export const AUTHLEVEL_OPTION = {
  authLevelOptions: [{
    value: USE_POWER.authLevelZero,
    label: '5'
  }, {
    value: USE_POWER.authLevelOne,
    label: '10'
  },
  {
    value: USE_POWER.authLevelTwo,
    label: '15'
  }
  ]
}
/*
 * 步长选项初始值
 */
export const TIME_OPTION = {
  timeTypeOptions: [{
    value: '00:05'
  }, {
    value: '00:10'
  }, {
    value: '00:15'
  }, {
    value: '00:20'
  }, {
    value: '00:30'
  }, {
    value: '01:00'
  }]
}
/*
 * 时间选项初始值
 */

export const TIMETYPE_OPTION = {
  timeTypeOptions: [{
    value: TIME_TYPE.step,
    label: '步长模式'
  }, {
    value: TIME_TYPE.free,
    label: '自由模式'
  }]
}
/*
 * 日期选项初始值
 */
export const DATETYPE_OPTION = {
  dateTypeOptions: [{
    value: DATE_TYPE.year,
    label: '年'
  }, {
    value: DATE_TYPE.month,
    label: '年/月'
  },
  {
    value: DATE_TYPE.week,
    label: '年/周'
  },
  {
    value: DATE_TYPE.date,
    label: '年/月/日'
  },
  {
    value: DATE_TYPE.dateTime,
    label: '年/月/日/时间'
  }
  ]
}
/*
 *日期间隔选项初始值
 */
export const DATESPAN_OPTION = {
  dateSpanOptions: [{
    value: DATE_TYPE.date,
    label: '年/月/日'
  },
  {
    value: DATE_TYPE.dateTime,
    label: '年/月/日/时间'
  }
  ]
}
/**
 * 验证正负初始值
 */
export const SYMBOLTYPE_OPTION = {
  plusMinusTypeOptions: [{
    value: SYMBOL_TYPE.symbol,
    label: '正负'
  }, {
    value: SYMBOL_TYPE.plus,
    label: '正'
  },
  {
    value: SYMBOL_TYPE.minus,
    label: '负'
  }
  ]
}
/**
 *  正则表达式类型
 */
export const REGEXP_TYPE = {
  // 中国手机号
  phone: 1,
  // 中国电话号码
  telephone: 2,
  // 邮箱
  email: 3,
  // url
  url: 4,
  // 字母+数字
  letterNum: 5,
  // 中国身份证
  chinaCard: 6,
  // 自定义
  custom: 0
}
/**
 * 表单分类
 */
export const CATEGORY_FORM = {
  // 分类ID
  id: null,
  // 分类名
  name: null,
  //  排序
  sort: 0,
  // 创建时间
  createdAt: null,
  // 修改时间
  modifiedAt: null
}
/**
 * 表单设置
 */
export const FORM_SETTING = [{
  id: PAGEMODE_TYPE.top,
  name: '顶部'
}, {
  id: PAGEMODE_TYPE.left,
  name: '左侧'
}]
/**
 * 表单详情界面配置
 */
export const FORM_FILL_CONFIG = {
  pageMode: PAGEMODE_TYPE.top
}
/**
 * 表单初始值
 */
export const SMART_FORM = {
  categoryId: null,
  // 表单名
  name: null,
  // 表单备注
  remarks: null,
  // 表单描述
  des: null,
  // 分页列表
  pageList: [{
    name: '第 1 页',
    // 分页填写优先级
    priority: 0,
    // 分页排序
    sort: 0,
    fieldList: []
  }],
  // 组件复杂条件规则列表
  conditionRules: [],
  initConditionRules: [],
  fieldMapperList: [
    {
      // 3，组件状态关系表
      mapperType: 3,
      dataType: 1,
      alias: '',
      dbAlias: 'stcsm_formcontent_component_state'
    }, {
      // 4，上传列表
      mapperType: 4,
      dataType: 1,
      alias: '',
      dbAlias: 'stcsm_formcontent_uploads'
    }],
  extraSetting: { ...FORM_FILL_CONFIG }
}

/**
 * 表单分页初始值
 */

export const FORM_PAGE = {
  name: null,
  // 分页填写优先级
  priority: 0,
  // 分页排序
  sort: 0,
  fieldList: []
}
/**
 * 表单基本控件类型
 */
export const BASE_WIDGETS = [{
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.number,
  name: '数字文本',
  ico: 'icon iconfont icon-icon-176',
  state: WIDGET_STATE.base,
  id: '1',
  defValue: null,
  suffixType: SUFFIX_TYPE.text,
  suffix: '',
  useSql: false,
  sqlStr: '',
  rules: [{
    ...RULE_DECIMAL,
    enable: true,
    decimal: false
  }]
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.input,
  name: '文本框',
  ico: 'icon iconfont icon-icon-136',
  state: WIDGET_STATE.base,
  id: '2',
  defValue: null,
  suffixType: SUFFIX_TYPE.text,
  suffix: '',
  isOtherInput: false // 是否开启其他的input选项
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.textarea,
  name: '多行文本',
  ico: 'icon iconfont icon-icon-104',
  defValue: null,
  state: WIDGET_STATE.base,
  id: '3'
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.radio,
  name: '单选框',
  ico: 'icon iconfont icon-icon-175',
  state: WIDGET_STATE.base,
  id: '4',
  defValue: null,
  sourceID: null,
  disables: [],
  minSelect: 0,
  maxSelect: 0,
  options: []
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.checkbox,
  name: '复选框',
  ico: 'icon iconfont icon-icon-77',
  state: WIDGET_STATE.base,
  id: '5',
  defValue: [], // 选中的值
  otherValue: '', // 选中其他时输入的值
  sourceID: null,
  disables: [],
  minSelect: 0,
  maxSelect: 15,
  options: []
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.select,
  name: '单级下拉',
  ico: 'icon iconfont icon-icon-75',
  state: WIDGET_STATE.base,
  id: '6',
  defValue: null,
  sourceID: null,
  disables: [],
  multi: false,
  clear: true,
  filterable: false,
  minSelect: 0,
  maxSelect: 5,
  options: []
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.cascader,
  name: '多级下拉',
  ico: 'icon iconfont icon-icon-115',
  dataSourceLevel: '2',
  dataSourceMin: '0',
  dataSourceMax: '6',
  state: WIDGET_STATE.base,
  id: '7',
  defValue: null,
  sourceID: null,
  disables: [],
  clear: true,
  filterable: false,
  remote: 0,
  arbitrarily: 0,
  options: []
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.date,
  name: '日期',
  ico: 'icon iconfont icon-icon-28',
  defValue: null,
  state: WIDGET_STATE.base,
  id: '8',
  ...DATE_PROPS
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.dateSpan,
  name: '日期间隔',
  ico: 'icon iconfont icon-icon-28',
  defValue: [],
  state: WIDGET_STATE.base,
  id: '9',
  ...DATE_PROPS
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.time,
  name: '时间',
  ico: 'icon iconfont icon-icon-36',
  defValue: null,
  state: WIDGET_STATE.base,
  id: '10',
  ...TIME_PROPS
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.timeSpan,
  name: '时间间隔',
  ico: 'icon iconfont icon-icon-36',
  defValue: [],
  state: WIDGET_STATE.base,
  id: '11',
  ...TIME_PROPS
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.upload,
  // 上传文件类型，用于业务标记
  uploadType: 0,
  name: '文件上传',
  ico: 'icon iconfont icon-icon-86',
  state: WIDGET_STATE.base,
  id: '12',
  minCount: 1,
  maxCount: 5,
  size: 10240,
  suffixd: '.jpg,.png'
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.editor,
  name: '富文本',
  ico: 'icon iconfont icon-icon-171',
  state: WIDGET_STATE.base,
  id: '13',
  defValue: null,
  imgUpload: true,
  imgSize: 2048,
  imgSuffix: '.jpg,.png',
  videoUpload: false,
  videoSize: 0,
  videoSuffix: ''
}, {
  ...WIDGET,
  type: PAGE_FIELD_TYPE.widget,
  fieldType: FIELD_TYPE.label,
  name: '文本描述',
  ico: 'icon iconfont icon-icon-136',
  hide: false,
  isSelect: false,
  // 是否可以设置，如果false则该控件的设置不可改动
  setting: true,
  // 文本框的值
  defValue: '请配置文本描述',
  // 文本框的css
  css: '',
  // 分割线：1，上分割线；2，下分割线；3，上下都有
  splitLine: LABEL_SPLIT_TYPE.both
}, {
  type: PAGE_FIELD_TYPE.group,
  name: '样式组',
  ico: 'icon iconfont icon-icon-140',
  state: WIDGET_STATE.base,
  id: '14',
  // 组类型 1（超级组件），2（样式组/单行组），3（表格组/可复制组）
  groupType: GROUP_TYPE.style,
  // 是否禁用
  disable: false,
  // 是否隐藏
  hide: false,
  des: '',
  isSelect: false,
  // 字段列表
  fieldList: [],
  // 是否可删除
  canDelete: true
}, {
  type: PAGE_FIELD_TYPE.group,
  name: '汇总表格',
  ico: 'icon iconfont icon-icon-140',
  state: WIDGET_STATE.base,
  id: '15',
  // 组类型 1（超级组件），2（样式组/单行组），3（表格组/可复制组）
  groupType: GROUP_TYPE.table,
  // 可控表格，每一行都可以不同
  steerable: true,
  // 数据库名
  dbName: '',
  // 数据库表名
  table: '',
  // 业务类型(int)，用于识别一个表单中拖入两个相同的超级组件的情况
  workType: 0,
  // 是否禁用
  disable: false,
  // 是否隐藏
  hide: false,
  des: '',
  // 表头规则
  tableHeadRules: [],
  // 公式规则列表
  formulaRules: [],
  // 合计规则列表
  totalRules: [],
  defLine: 1,
  linenum: false,
  customLinenum: false,
  linenumList: [],
  lineList: [{
    // 行类型
    lineType: GROUP_LINE_TYPE.common,
    lineNum: 1,
    fieldList: [],
    isClone: false
  }],
  isSelect: false,
  // 是否可删除
  canDelete: true
}, {
  type: PAGE_FIELD_TYPE.group,
  name: '表格组',
  ico: 'icon iconfont icon-icon-140',
  state: WIDGET_STATE.base,
  id: '16',
  // 组类型 1（超级组件），2（样式组/单行组），3（表格组/可复制组）
  groupType: GROUP_TYPE.table,
  // 数据库名
  dbName: '',
  // 数据库表名
  table: '',
  // 业务类型(int)，用于识别一个表单中拖入两个相同的超级组件的情况
  workType: 0,
  // 是否禁用
  disable: false,
  // 是否隐藏
  hide: false,
  des: '',
  // 公式规则列表
  formulaRules: [],
  // 合计规则列表
  totalRules: [],
  // 汇总表规则（只有一个字段id数组）
  gridViewRules: [],
  // 表头规则，与汇总规则不可共存
  tableHeadRules: [],
  // 组件复杂条件规则列表
  conditionRules: [],
  defLine: 1,
  fillAdd: false,
  minAdd: 0,
  maxAdd: 10,
  linenum: false,
  customLinenum: false,
  linenumList: [],
  lineList: [{
    // 行类型
    lineType: GROUP_LINE_TYPE.common,
    lineNum: 1,
    fieldList: [],
    isClone: false
  }],
  // 原始行，用于用户新加时拷贝
  originalLine: null,
  // 固定行列表
  fixedLineList: [],
  // 回退状态的组Id列表
  stateBackGorups: [],
  // 选填
  selectFill: false,
  // 关联表设置
  relationSet: null,
  isSelect: false,
  // 是否可删除
  canDelete: true,
  // 是否选填，默认否
  optional: false
}]

/**
 * 超级组件
 */
export const SUPER_GROUP = {
  type: PAGE_FIELD_TYPE.group,
  name: '定制组件',
  ico: 'icon iconfont icon-icon-140',
  state: WIDGET_STATE.base,
  id: '17',
  // 组类型 1（超级组件），2（样式组/单行组），3（表格组/可复制组）
  groupType: GROUP_TYPE.super,
  // 是否显示标题,（超级组件）
  showName: false,
  // 是否显示边框样式,（超级组件）
  showStyle: false,
  // 是否禁用
  disable: false,
  // 数据库名
  dbName: '',
  // 数据库表名
  table: '',
  // 业务类型(int)，用于识别一个表单中拖入两个相同的超级组件的情况
  workType: 0,
  // 是否隐藏
  hide: false,
  des: '',
  // 公式规则列表
  formulaRules: [],
  // 组件复杂条件规则列表
  conditionRules: [],
  isSelect: false,
  // 字段列表
  fieldList: [],
  // 是否可删除
  canDelete: false
}

/**
 * 关联组设置（表格组嵌套）
 */
export const RELATON_GROUP_SETTING = {
  // 关联表表名
  table: '',
  // 关联ID别名
  alias: '',
  // 关联下拉控件标题
  selectTitle: '',
  // 筛选条件
  where: ''
}

/**
 * 运算类型
 */
// 1.算数运算符 2.合计运算符 3.字段
export const CALCULATE_TYPE = {
  operator: 1,
  totalFun: 2,
  field: 3
}
/**
 * 合计类型
 */
// 1.总和 2.平均值 3.最小 4.最大
export const TOTAL_FUN_TYPE = {
  sum: 1,
  averge: 2,
  min: 3,
  max: 4,
  count: 5
}

/**
 * 运算符类型
 */
// 1.加 2.减 3.乘 4.除 5.等于 6.大于 7.小于 8.大于等于 9.小于等于 10.不等于 11.或 12.和 13.结果
export const OPERATOR_FUN_TYPE = {
  add: 1,
  minus: 2,
  multiply: 3,
  division: 4,
  equal: 5,
  greaterThan: 6,
  lessThan: 7,
  greaterThanAndEqual: 8,
  lessThanAndEqual: 9,
  notEqual: 10,
  or: 11,
  and: 12,
  result: 13
}
/**
 * 合计类型
 */
// 1.总和 2.平均值 3.最小 4.最大
export const TOTAL_FUN_TYPEOPTION = [{
  id: TOTAL_FUN_TYPE.sum,
  type: CALCULATE_TYPE.totalFun,
  name: 'SUM'
},
{
  id: TOTAL_FUN_TYPE.averge,
  type: CALCULATE_TYPE.totalFun,
  name: 'AVERGE'
}, {
  id: TOTAL_FUN_TYPE.min,
  type: CALCULATE_TYPE.totalFun,
  name: 'MIN'
}, {
  id: TOTAL_FUN_TYPE.max,
  type: CALCULATE_TYPE.totalFun,
  name: 'MAX'
}, {
  id: TOTAL_FUN_TYPE.count,
  type: CALCULATE_TYPE.totalFun,
  name: 'COUNT'
}
]
/**
 * 运算符类型选项
 */
// 1.加 2.减 3.乘 4.除 5.等于
export const OPERATOR_FUN_TYPEOPTION = [{
  id: OPERATOR_FUN_TYPE.add,
  type: CALCULATE_TYPE.operator,
  name: '+'
}, {
  id: OPERATOR_FUN_TYPE.minus,
  type: CALCULATE_TYPE.operator,
  name: '-'
}, {
  id: OPERATOR_FUN_TYPE.multiply,
  type: CALCULATE_TYPE.operator,
  name: '*'
}, {
  id: OPERATOR_FUN_TYPE.division,
  type: CALCULATE_TYPE.operator,
  name: '/'
}, {
  id: OPERATOR_FUN_TYPE.equal,
  type: CALCULATE_TYPE.operator,
  name: '='
}]
// 组规则公式数据实体
export const GROUP_FORMULA_RULE = [{
  id: '',
  groupId: '',
  // 运算单元
  operatorList: [{
    type: '',
    totalType: '',
    fieldList: [],
    // 运算符类型
    operatorType: '',
    // 汇总表格行号
    lineNum: 0,
    // 运算的字段ID
    fieldId: '',
    // 值类型，1，常量；2，正则；3，跨表（日期Long）
    valueType: 1,
    // 计算用值
    value: ''
  }]
}]
// 组规则合计数据实体
export const GROUP_TOTAL_RULE = [{
  id: '',
  // 合计行标题
  name: '',
  // 运算行行号列表，int数组
  operationList: [],
  // 结果行行号，int
  resultLine: 0,
  // 具体合计的列
  fieldList: [],
  // 合计排序，用于执行顺序
  sort: 0
}]

// 合计行
export const GROUP_TOTAL_LINE = {
  lineType: GROUP_LINE_TYPE.total,
  lineNum: '',
  columnNum: '',
  fieldList: [],
  isClone: false
}

/**
 * 映射类型：1，参数；2，字段别名（表名.别名）；3，组件状态关系表；4，上传列表
 */
export const FMAPPER_TYPEOPTION = [{
  id: FMAPPER_TYPE.alias,
  name: '表单字段'
}, {
  id: FMAPPER_TYPE.stateTable,
  name: '组件状态表'
}, {
  id: FMAPPER_TYPE.uploadTable,
  name: '上传列表'
}, {
  id: FMAPPER_TYPE.endDate,
  name: '结束时间'
}]
/**
 * 对应字段的数据类型：1，字符串；2，Long(日期)
 */
export const FMAPPER_DATA_TYPEOPTION = [{
  id: FMAPPER_DATA_TYPE.string,
  name: '字符串'
}, {
  id: FMAPPER_DATA_TYPE.long,
  name: 'Long(日期)'
}]

// /**
//  * 表格组的汇总表固定字段ID
//  */
// export const GROUP_GRID_FIELD = {
//   createdAt: 'created_at',
//   modifiedAt: 'modified_at',
//   sort: 'sort'
// }

// /**
//  * 表格组的汇总表固定字段选项
//  */
// export const GROUP_GRID_FIELDOPTION = [{
//   id: GROUP_GRID_FIELD.createdAt,
//   name: '创建时间'
// }, {
//   id: GROUP_GRID_FIELD.modifiedAt,
//   name: '修改时间'
// }, {
//   id: GROUP_GRID_FIELD.sort,
//   name: '排序'
// }]

/**
 * 表格表头数据对象
 */
export const GROUP_TABLE_HEAD = {
  // 表头名称，对应旗下每行的字段标题
  name: '',
  // 宽度百分比
  widthRatio: 20
}

/**
 * 数据源选项
 */
export const DATA_SOURCE_OPTIONS = [{
  value: 'project-declare',
  label: '项目申报数据源'
}, {
  value: 'master',
  label: '表单内部数据源'
}]

/**
 * 复杂条件规则
 */
export const CONDITIONAL_RULE = {
  // 字段类型，目前只支持number，单选，复选，下拉
  fieldType: FIELD_TYPE.number,
  // 条件字段Id
  fieldId: '',
  // 条件关系运算符
  relationOperator: 0,
  // 判定条件
  condition: '',
  // 要处理的组件列表
  widgetList: [],
  // 字段列表是否有组件
  hasGroup: false,
  // 条件字段表名
  table: '',
  // 条件字段别名
  alias: '',
  // 是否处理（前端属性）
  processed: false
}
/**
 * 复杂条件要处理的组件实体
 */
export const CONDITIONAL_WIDGET = {
  type: PAGE_FIELD_TYPE.group,
  // 所在分页ID
  pageId: null,
  // 要处理的组件
  groupId: '',
  hide: false,
  disable: false,
  // 汇总表格字段需要带行号
  lineNum: null,
  // 要处理的字段
  field: {
    id: null,
    // sql设置 不做处理赋值null
    sqlStr: null,
    // 默认值设置 不做处理赋值null
    defValue: null,
    // 放置选取的规则，必填自动填充进来
    rules: []
  },
  // 存放缓存（前端用）
  original: {}
}
/**
 * 关联表规则格式
 */
export const RELATION_RULE = {
  // 父关联表表名
  table: null,
  // lineId别名
  alias: null,
  // SQL筛选条件
  where: null,
  // 是否自动删除数据
  autoDel: true
}
/**
 * 深拷贝对象
 * @param {*} obj
 */
export const deepClone = function (obj) {
  let objClone = Array.isArray(obj) ? [] : {}
  if (obj && typeof obj === 'object') {
    for (let key in obj) {
      if (obj.hasOwnProperty(key)) {
        // 判断ojb子元素是否为对象，如果是，递归复制
        if (obj[key] && typeof obj[key] === 'object') {
          // 深拷贝日期类型
          if (obj[key] instanceof Date) {
            objClone[key] = new Date(obj[key].valueOf())
            // console.log('deepClone', objClone[key])
          } else {
            objClone[key] = deepClone(obj[key])
          }
        } else {
          // 如果不是，简单复制
          objClone[key] = obj[key]
        }
      }
    }
  }
  return objClone
}

/**
 * 深拷贝赋值，不支持数组
 * @param {*} obj
 */
export const deepCloneAssign = function (obj, setObj) {
  if (obj && typeof obj === 'object') {
    for (let key in obj) {
      if (obj.hasOwnProperty(key)) {
        // 判断ojb子元素是否为对象，如果是，递归复制
        if (obj[key] && typeof obj[key] === 'object') {
          deepCloneAssign(obj[key], setObj[key])
        } else {
          // 如果不是，简单复制
          setObj[key] = obj[key]
        }
      }
    }
  }
}
/**
 * 运算符类型选项
 */
// +,-,*,/,=,>,<,<=,>=,!=,or,and，result
export const CUSTOM_SYMBOL_TYPEOPTION = [
  {
    id: OPERATOR_FUN_TYPE.add,
    type: CALCULATE_TYPE.operator,
    name: '+'
  }, {
    id: OPERATOR_FUN_TYPE.minus,
    type: CALCULATE_TYPE.operator,
    name: '-'
  }, {
    id: OPERATOR_FUN_TYPE.multiply,
    type: CALCULATE_TYPE.operator,
    name: '*'
  }, {
    id: OPERATOR_FUN_TYPE.division,
    type: CALCULATE_TYPE.operator,
    name: '/'
  }, {
    id: OPERATOR_FUN_TYPE.equal,
    type: CALCULATE_TYPE.operator,
    name: '='
  }, {
    id: OPERATOR_FUN_TYPE.greaterThan,
    type: CALCULATE_TYPE.operator,
    name: '>'
  }, {
    id: OPERATOR_FUN_TYPE.lessThan,
    type: CALCULATE_TYPE.operator,
    name: '<'
  }, {
    id: OPERATOR_FUN_TYPE.greaterThanAndEqual,
    type: CALCULATE_TYPE.operator,
    name: '>='
  }, {
    id: OPERATOR_FUN_TYPE.lessThanAndEqual,
    type: CALCULATE_TYPE.operator,
    name: '<='
  }, {
    id: OPERATOR_FUN_TYPE.notEqual,
    type: CALCULATE_TYPE.operator,
    name: '!='
  }, {
    id: OPERATOR_FUN_TYPE.or,
    type: CALCULATE_TYPE.operator,
    name: 'or'
  }, {
    id: OPERATOR_FUN_TYPE.and,
    type: CALCULATE_TYPE.operator,
    name: 'and'
  }, {
    id: OPERATOR_FUN_TYPE.result,
    type: CALCULATE_TYPE.operator,
    name: 'result'
  }
]

/**
 * 条件运算符类型选项
 */
// =,!=
export const CONDITION_SYMBOL_TYPEOPTION = [
  {
    id: OPERATOR_FUN_TYPE.equal,
    type: CALCULATE_TYPE.operator,
    name: '='
  },
  {
    id: OPERATOR_FUN_TYPE.notEqual,
    type: CALCULATE_TYPE.operator,
    name: '!='
  }
]

export const NUMBER_SYMBOL_TYPEOPTION = [
  {
    id: OPERATOR_FUN_TYPE.equal,
    type: CALCULATE_TYPE.operator,
    name: '='
  },
  {
    id: OPERATOR_FUN_TYPE.notEqual,
    type: CALCULATE_TYPE.operator,
    name: '!='
  }, {
    id: OPERATOR_FUN_TYPE.greaterThanAndEqual,
    type: CALCULATE_TYPE.operator,
    name: '>='
  }, {
    id: OPERATOR_FUN_TYPE.lessThanAndEqual,
    type: CALCULATE_TYPE.operator,
    name: '<='
  }
]

/**
 * 不同文件类型存储的文件夹
 * @param {*} file
 */
export const getFileType = function (file) {
  if (file && file.type) {
    if (file.type.indexOf('image') !== -1) {
      return 'image'
    } else if (file.type.indexOf('audio') !== -1) {
      return 'audio'
    } else if (file.type.indexOf('pdf') !== -1) {
      return 'pdf'
    } else {
      return 'file'
    }
  }
}
