import { FIELD_TYPE } from '@/utils/crfForm/widgetsConstants'
/**
 * 处理控件的默认值
 */
export const DEFAULT_VALUE_HANDLER_OBJ = {
  formContentMap: {},
  getDefaultValue(data, formContentData) {
    // 将表单内容填充到对应的位置
    if (!formContentData || JSON.stringify(formContentData) === '{}') {
      return
    }
    if (data.defValue === '' || data.defValue === undefined || data.defValue === null || (data.defValue && data.defValue.length === 0)) {
      data.defValue = formContentData[data.id]
    }
    if (data.fieldType === FIELD_TYPE.rangeSpan || data.fieldType === FIELD_TYPE.numRangeSpan) {
      // 文本范围/数字文本范围
      // leftData rightData selUnit selCheckBox
      data.leftData.defValue = formContentData[data.id].leftData
      data.rightData.defValue = formContentData[data.id].rightData
      data.selUnit.defValue = formContentData[data.id].selUnit
      data.selCheckBox.defValue = formContentData[data.id].selCheckBox
      data.defValue = formContentData[data.id].defValue
    } else if (data.fieldType === FIELD_TYPE.radio || data.fieldType === FIELD_TYPE.checkbox || data.fieldType === FIELD_TYPE.select) {
      // 单选框/复选框/单级下拉
      if (data.hasOtherInput) {
        // 开启了是否显示‘其他’
        // otherInput
        data.otherInput.defValue = formContentData[data.id].otherInput
        // this.formContentMap[data.id].otherInput = data.otherInput.defValue
      }
    }
  },
  setDefaultValue(data, formContentData) {
    // 保存表单内容
    debugger
    if (data.defValue !== '' && data.defValue !== undefined && data.defValue !== null) {
      formContentData[data.id] = data.defValue
      // 以下数据格式是为了扩充别名
      formContentData[data.id] = {}
      formContentData[data.id]['defValue'] = data.defValue
      formContentData[data.id]['alias'] = data.alias
    }
    if (data.fieldType === FIELD_TYPE.rangeSpan || data.fieldType === FIELD_TYPE.numRangeSpan) {
      // 文本范围/数字文本范围
      // leftData rightData selUnit selCheckBox
      // 组合控件的格式为 'data.id'： {defValue: '', leftData: '',...}
      formContentData[data.id] = {}
      formContentData[data.id]['defValue'] = data.defValue
      formContentData[data.id]['alias'] = data.alias
      formContentData[data.id]['leftData'] = data.leftData.defValue
      formContentData[data.id]['alias'] = data.leftData.alias
      formContentData[data.id]['rightData'] = data.rightData.defValue
      formContentData[data.id]['alias'] = data.rightData.alias
      formContentData[data.id]['selUnit'] = data.selUnit.defValue
      formContentData[data.id]['alias'] = data.selUnit.alias
      formContentData[data.id]['selCheckBox'] = data.selCheckBox.defValue
      formContentData[data.id]['alias'] = data.selCheckBox.alias
    } else if (data.fieldType === FIELD_TYPE.radio || data.fieldType === FIELD_TYPE.checkbox || data.fieldType === FIELD_TYPE.select) {
      // 单选框/复选框/单级下拉
      if (data.hasOtherInput) {
        // 开启了是否显示‘其他’
        // otherInput
        formContentData[data.id] = {}
        formContentData[data.id].otherInput = data.otherInput.defValue
      }
    }
    return formContentData
  }
}
