// import { DEEP_CLONE } from '@/utils/constants'
import {
  PAGE_FIELD_TYPE,
  GROUP_TYPE
} from '@/utils/crfForm/constants'
// import { FIELD_TYP } from '@/utils/crfForm/widgetsConstants'
export default {
  /**
 * 表单数据结构遍历
 * @param {*Array} data 数据
 * @param {*Object} handleObj 事件处理对象
 * @param {*Object} parentObj 父级数据
 * @param {*Number} isStopType 0，不停止；1,遇到表格停止；2，遇到行停止；
 * @param {*Array} formContentData 当渲染表单的时候用到，表示填写的表单内容
 */
  formDataMap(data, handleObj, formContentData, isStopType = 0, parentObj = null) {
    // 表格组、样式组、表格组行、originalLine、控件、是否停止遍历
    for (let attr in handleObj) {
      // 当事件处理对象中有数组的时候，再次调用的时候将数组置空
      if (Array.isArray(handleObj[attr])) {
        handleObj[attr] = []
      }
    }
    // if (handleObj.formContentMap.hasOwnProperty(data.id)) {
    //   handleObj.formContentMap = {}
    // }
    for (let i = 0; i < data.length; i++) {
      let nowData = data[i]
      if (handleObj.formContentMap && handleObj.formContentMap.hasOwnProperty(nowData.id)) {
        handleObj.formContentMap = {}
      }
      if (nowData.type === PAGE_FIELD_TYPE.group) {
        if (nowData.groupType === GROUP_TYPE.style) {
          // 样式组
          handleObj.styleGroupHandle && handleObj.styleGroupHandle(data, parentObj)
          if (nowData.fieldList && nowData.fieldList.length > 0) {
            this.formDataMap(nowData.fieldList, handleObj, formContentData, isStopType, nowData)
          }
        } else if (nowData.groupType === GROUP_TYPE.table) {
          // 表格组
          handleObj.tableHandle(nowData, parentObj, formContentData)
          // 是否遍历到表格停止
          if (isStopType === 1) {
            continue
          } else {
            if (!nowData.lineList || nowData.lineList.length === 0) {
              continue
            }
            // 遍历行
            for (let line of nowData.lineList) {
              let lineCount = 0
              handleObj.lineHandle && handleObj.lineHandle(line, nowData)
              if (!line.fieldList || line.fieldList.length === 0) {
                continue
              }
              // 遍历列
              for (let field of line.fieldList) {
                handleObj.widgetHandle && handleObj.widgetHandle(field, line, formContentData, lineCount, nowData)
              }
              lineCount++
            }
          }
        }
      } else if (nowData.type === PAGE_FIELD_TYPE.widget) {
        // 控件
        handleObj.widgetHandle && handleObj.widgetHandle(nowData, parentObj, formContentData)
      }
    }
    return handleObj
  },
  lineMap(lineList, group, handleObj, isStopType) {
    // 遍历行
    for (let line of lineList) {
      handleObj.lineHandle(line, group)
      // 是否遍历到行停止
      if (isStopType === 2) {
        continue
      }
      let lineCount = 0
      if (!line.fieldList || line.fieldList.length === 0) {
        continue
      }
      // 遍历列
      for (let field of line.fieldList) {
        handleObj.widgetHandle(field, line, lineCount, group)
      }
      lineCount++
    }
  },
  tableHandle(data, sceneType, isStopMap) {
    // 表格组数据处理
    if (sceneType === 'submit' || sceneType === 'saveFormContent') {
      if (data.lineList) {
        this.formSubmitFormat(data.lineList[0].fieldList, sceneType, isStopMap)
      }
    }
  },
  formQueryInit() {
    // 表单dom结构获取之后进行初始化处理
    /**
     * 1. 是否有动态源，有的话去动态获取动态源对应的数据，进行数据填充
     */
  }
}
