import { DEEP_CLONE } from '@/utils/constants'
/**
 * 表单数据结构遍历
 * @param {*} data 数据
 * @param {*} flag 标志
 * @param {*} arr 数组
 */
export const FORM_DATA_MAP = (data, flag = false, arr = []) => {
  let deepData = DEEP_CLONE(data)
  for (let i = 0; i < deepData.length; i++) {
    if (!flag) {
      if (deepData[i].leftData || deepData[i].rightData) {
        arr.push({
          id: deepData[i].id,
          defValue: deepData[i].defValue,
          lackValueId: deepData[i].lackValueId,
          name: deepData[i].name,
          type: deepData[i].type,
          leftData: {
            id: deepData[i].leftData.id,
            defValue: deepData[i].leftData.defValue,
            lackValueId: deepData[i].leftData.lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            fieldList: []
          },
          rightData: {
            id: deepData[i].rightData.id,
            defValue: deepData[i].rightData.defValue,
            lackValueId: deepData[i].rightData.lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            fieldList: []
          },
          fieldList: []
        })
      } else if (deepData[i].originalLine) {
        // 表格组
        arr.push({
          id: deepData[i].id,
          defValue: deepData[i].defValue,
          lackValueId: deepData[i].lackValueId,
          name: deepData[i].name,
          type: deepData[i].type,
          originalLine: {
            fieldList: []
          }
        })
        FORM_DATA_MAP(deepData[i].originalLine.fieldList, true, arr)
      } else {
        // 第一次
        if (deepData[i].otherInput) {
          // 复选款、单选框、单级下拉选择了开启显示‘其他’输入框
          arr.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            fieldList: [],
            otherInput: {
              id: deepData[i].otherInput.id,
              defValue: deepData[i].otherInput.defValue,
              lackValueId: deepData[i].otherInput.lackValueId,
              name: deepData[i].otherInput.name,
              type: deepData[i].otherInput.type,
              fieldList: []
            }
          })
        } else {
          arr.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            fieldList: []
          })
        }
      }
    } else {
      // 递归,找到需要递归的父节点
      if (arr[arr.length - 1].type === 1) {
        arr[arr.length - 1].fieldList.push({
          id: deepData[i].id,
          defValue: deepData[i].defValue,
          lackValueId: deepData[i].lackValueId,
          name: deepData[i].name,
          fieldList: []
        })
      } else if (arr[arr.length - 1].type === 2) {
        // 表格
        arr[arr.length - 1].originalLine.fieldList.push({
          id: deepData[i].id,
          defValue: deepData[i].defValue,
          lackValueId: deepData[i].lackValueId,
          name: deepData[i].name,
          fieldList: []
        })
      }
    }
    if (deepData[i].fieldList && deepData[i].fieldList.length > 0) {
      // flag = true // 递归
      FORM_DATA_MAP(deepData[i].fieldList, true, arr)
    }
  }
  return arr
}
export default {
  /**
 * 表单数据结构遍历
 * @param {*} data 数据
 * @param {*} flag 标志
 * @param {*} arr 数组
 */
  formDataMap(data, flag = false, arr = []) {
    let deepData = DEEP_CLONE(data)
    for (let i = 0; i < deepData.length; i++) {
      if (!flag) {
        if (deepData[i].leftData || deepData[i].rightData) {

        } else if (deepData[i].originalLine) {
          // 表格组
          arr.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            originalLine: {
              fieldList: []
            }
          })
          FORM_DATA_MAP(deepData[i].originalLine.fieldList, true, arr)
        } else {
          // 第一次
          if (deepData[i].otherInput) {
            // 复选款、单选框、单级下拉选择了开启显示‘其他’输入框

          } else {
            arr.push({
              id: deepData[i].id,
              defValue: deepData[i].defValue,
              lackValueId: deepData[i].lackValueId,
              name: deepData[i].name,
              type: deepData[i].type,
              fieldList: []
            })
          }
        }
      } else {
        // 递归,找到需要递归的父节点
        if (arr[arr.length - 1].type === 1) {
          arr[arr.length - 1].fieldList.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            fieldList: []
          })
        } else if (arr[arr.length - 1].type === 2) {
          // 表格
          arr[arr.length - 1].originalLine.fieldList.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            fieldList: []
          })
        }
      }
      if (deepData[i].fieldList && deepData[i].fieldList.length > 0) {
        FORM_DATA_MAP(deepData[i].fieldList, true, arr)
      }
    }
    return arr
  },
  /**
   * 使用场景： 保存填写的表单内容，如保存填写的随访记录；只保存一些必要的字段和默认值字段
   * @param {*} data 表单的数据 this.currentPage.fieldList
   * @param {*} flag 标志是否递归
   * @param {*} arr 存储处理后的数据
   */
  saveDefaultVal(data, flag = false, arr = []) {
    let deepData = DEEP_CLONE(data)
    for (let i = 0; i < deepData.length; i++) {
      if (!flag) {
        if (deepData[i].leftData || deepData[i].rightData) {
          arr.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            leftData: {
              id: deepData[i].leftData.id,
              defValue: deepData[i].leftData.defValue,
              lackValueId: deepData[i].leftData.lackValueId,
              name: deepData[i].name,
              type: deepData[i].type,
              fieldList: []
            },
            rightData: {
              id: deepData[i].rightData.id,
              defValue: deepData[i].rightData.defValue,
              lackValueId: deepData[i].rightData.lackValueId,
              name: deepData[i].name,
              type: deepData[i].type,
              fieldList: []
            },
            fieldList: []
          })
        } else if (deepData[i].originalLine) {
          // 表格组
          arr.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            type: deepData[i].type,
            originalLine: {
              fieldList: []
            }
          })
          this.saveDefaultVal(deepData[i].originalLine.fieldList, true, arr)
        } else {
          // 第一次
          if (deepData[i].otherInput) {
            // 复选款、单选框、单级下拉选择了开启显示‘其他’输入框
            arr.push({
              id: deepData[i].id,
              defValue: deepData[i].defValue,
              lackValueId: deepData[i].lackValueId,
              name: deepData[i].name,
              type: deepData[i].type,
              fieldList: [],
              otherInput: {
                id: deepData[i].otherInput.id,
                defValue: deepData[i].otherInput.defValue,
                lackValueId: deepData[i].otherInput.lackValueId,
                name: deepData[i].otherInput.name,
                type: deepData[i].otherInput.type,
                fieldList: []
              }
            })
          } else {
            arr.push({
              id: deepData[i].id,
              defValue: deepData[i].defValue,
              lackValueId: deepData[i].lackValueId,
              name: deepData[i].name,
              type: deepData[i].type,
              fieldList: []
            })
          }
        }
      } else {
        // 递归,找到需要递归的父节点
        if (arr[arr.length - 1].type === 1) {
          arr[arr.length - 1].fieldList.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            fieldList: []
          })
        } else if (arr[arr.length - 1].type === 2) {
          // 表格
          arr[arr.length - 1].originalLine.fieldList.push({
            id: deepData[i].id,
            defValue: deepData[i].defValue,
            lackValueId: deepData[i].lackValueId,
            name: deepData[i].name,
            fieldList: []
          })
        }
      }
      if (deepData[i].fieldList && deepData[i].fieldList.length > 0) {
        FORM_DATA_MAP(deepData[i].fieldList, true, arr)
      }
    }
    return arr
  },
  /**
   * 表单渲染，应用场景：随访记录表单渲染
   *@param {*Array} defValueArr 缺省值数组
   * @param {*Array} list 存储随访计划表单结构数组
   */
  setFormDefault(defValueArr, list) {
    for (let i = 0; i < defValueArr.length; i++) {
      for (let j = 0; j < list.length; j++) {
        if (defValueArr[i].id === list[j].id) {
          list[j].defValue = defValueArr[i].defValue
          list[j].lackValueId = defValueArr[i].lackValueId
          if (list[j].leftData || list[j].rightData) {
            list[j].leftData.defValue = defValueArr[i].leftData ? defValueArr[i].leftData.defValue : ''
            list[j].leftData.lackValueId = defValueArr[i].leftData ? defValueArr[i].leftData.lackValueId : ''
            list[j].rightData.defValue = defValueArr[i].rightData ? defValueArr[i].rightData.defValue : ''
            list[j].rightData.lackValueId = defValueArr[i].rightData ? defValueArr[i].rightData.lackValueId : ''
          }
          // 表格组和显示其他控件
          if (list[j].type === 2 || list[j].originalLine) {
            // 表格组
            // 表格组需要递归
            this.setFormDefault(defValueArr[i].originalLine.fieldList, list[j].originalLine.fieldList)
          }
          if (list[j].otherInput && list[i].otherInput.id === defValueArr[i].otherInput.id) {
            list[j].otherInput.defValue = defValueArr[i].otherInput.defValue
            list[j].otherInput.lackValueId = defValueArr[i].otherInput.lackValueId
          }
          if (defValueArr[i].fieldList.length > 0) {
            this.setFormDefault(defValueArr[i].fieldList, list[j].fieldList)
          }
        }
      }
    }
    return list
  },
  formSubmitFormat(originalData) {
    // 设计表单---编辑表单之后保存表单，表单处理
    /*
      1.将动态源的数据存储的options去掉
      2.将标记哪个控件为选中的状态字段清空
    */
    // let deepData = DEEP_CLONE(originalData)
    let deepData = originalData
    for (let i = 0; i < deepData.length; i++) {
      if (deepData[i].leftData || deepData[i].rightData) {
        if (deepData[i].sourceID && deepData[i].sourceID.length > 0) {
          // 动态源
          deepData[i].options = []
        }
      } else if (deepData[i].originalLine) {
        // 表格组
        this.formSubmitFormat(deepData[i].originalLine.fieldList)
      } else {
        // 第一次
        if (deepData[i].sourceID && deepData[i].sourceID.length > 0) {
          // 动态源
          deepData[i].options = []
        }
        if (deepData[i].otherInput) {
          // 复选款、单选框、单级下拉选择了开启显示‘其他’输入框
          deepData[i].otherInput.isSelect = false
        }
      }
      deepData[i].isSelect = false
      if (deepData[i].fieldList && deepData[i].fieldList.length > 0) {
        this.formSubmitFormat(deepData[i].fieldList)
      }
    }
  },
  formQueryInit() {
    // 表单dom结构获取之后进行初始化处理
    /**
     * 1. 是否有动态源，有的话去动态获取动态源对应的数据，进行数据填充
     */
  }
}
