import {
  FIELD_TYPE,
  deepClone
} from '@/utils/crfForm/constants'
import store from '@/store/index'
import {
  DATA_SOURCE_INFO_TYPE
} from '@/utils/crfForm/widgetsConstants'
import FORM_DATA_HANDLE from '@/utils/crfForm/formDataStructure'
export const GET_OPTION_INFO_URL = '/saascrf/common/getElementDatas'
/**
 * 获取单选复选下拉数据
 * @param {Object} url 当前获取数据的路劲
 */
export const GET_OPTION_INFO = async function(url) {
  let options = await store.dispatch('getEmrOptions', url)
  if (options && options.data) {
    return options.data
  }
}
async function handleGetDataInfo(val) {
  if (val.fieldType === FIELD_TYPE.select || val.fieldType === FIELD_TYPE.checkbox ||
    val.fieldType === FIELD_TYPE.radio) {
    // 如果是静态数据源则重新获取options
    // 如果是动态数据源则直接使用保存的options
    // 静态数据源 重新获取
    if (val.dataSourceProperties === DATA_SOURCE_INFO_TYPE.static) {
      if (val.sourceInfo && val.sourceInfo.length > 0 && val.sourceID.length > 0) {
        let sysName = val.sourceInfo.find(i => i.type === 'system').sysName
        let codeType = val.sourceInfo.find(i => i.type === 'codeType').codeType
        let url = GET_OPTION_INFO_URL + '?sysName=' + sysName + '&codeType=' + codeType + '&parentCode=' + 0 + '&isAll=false'
        val.options = await GET_OPTION_INFO(url)
      }
    } else if (val.dataSourceProperties === DATA_SOURCE_INFO_TYPE.live) { // 动态不做处理
    }
  }
}
// 渲染编辑的表单dom结构
export const RENDER_FORM_OBJ = {
  // 样式组数据处理
  styleGroupHandle() {

  },
  // 表格组数据处理
  tableHandle(group) {
    group.originalLine = null
    console.log(group)
    if (!group.originalLine || (group.originalLine && !group.originalLine.fieldList)) {
      group.originalLine = deepClone(group.lineList[0])
    }
    if (group.originalLine && group.originalLine.fieldList) {
      group.originalLine.fieldList.forEach(groupField => {
        handleGetDataInfo(groupField)
      })
    }
    let minAdd
    if (group.fillAdd) {
      minAdd = group.minAdd
    } else {
      minAdd = 0
    }
    let cloneLineCount = group.defLine + minAdd + 1
    group.lineList = []
    for (let i = 1; i < cloneLineCount; i++) {
      const fristLine = deepClone(group.originalLine)
      // 处理已有的拷贝行
      if (i < group.lineList.length) {
        let copyLine = deepClone(group.lineList[i])
        let fieldList = []
        // 遍历当前拷贝行填充其除defValue的值
        copyLine.fieldList.forEach(field => {
          for (let fieldFrist of fristLine.fieldList) {
            if (fieldFrist.id === field.id) {
              fieldFrist.defValue = field.defValue
              fieldList.push(fieldFrist)
            }
          }
        })
        copyLine.fieldList = fieldList
      } else {
        // 清除复制首行的defValue
        // fristLine.fieldList.forEach(field => {
        //   field.defValue = ''
        // })
        group.lineList.push(fristLine)
      }
    }
  },
  // 表格行处理
  lineHandle() {

  },
  // 控件数据处理
  widgetHandle(data, parentObj) {
    handleGetDataInfo(data)
  }
}
export const RENDER_FORM__HANDLE = function (data, formContentData = [], isStopType = 0, parentObj = null) {
  FORM_DATA_HANDLE.formDataMap(data, RENDER_FORM_OBJ, formContentData, isStopType, parentObj)
}
