import { FIELD_TYPE } from '@/utils/crfForm/widgetsConstants'
import FORM_DATA_HANDLE from '@/utils/crfForm/formDataStructure'
// 保存编辑的表单dom结构
const SUBMIT_FORM_OBJ = {
  // 样式组数据处理
  styleGroupHandle() {

  },
  // 表格组数据处理
  tableHandle() {

  },
  // 表格行处理
  lineHandle() {

  },
  // 控件数据处理
  widgetHandle(data, parentObj) {
    if ((data.fieldType === FIELD_TYPE.numRangeSpan || data.fieldType === FIELD_TYPE.rangeSpan)) {
      // 数字文本范围/文本范围
      // 查找字段下面哪些字段有sourceId这个字段
      for (let attr in data) {
        if (data[attr] && data[attr].sourceID && data[attr].sourceID.length > 0) {
          data[attr].options = []
        }
        if (data[attr] && data[attr].isSelect && data[attr].isSelect) {
          data[attr].isSelect = false
        }
      }
    }
    if (data.sourceID && data.sourceID.length > 0) {
      // 动态源
      data.options = []
    }
    data.isSelect = false
  }
}

export function formSubmitFormat(originalData) {
  // 设计表单---编辑表单之后保存表单，表单处理
  /*
    1.将动态源的数据存储的options去掉
    2.将标记哪个控件为选中的状态字段清空
  */
  // let deepData = DEEP_CLONE(originalData)
  let deepData = originalData
  for (let i = 0; i < deepData.length; i++) {
    if (deepData[i].leftData || deepData[i].rightData) {
      if (deepData[i].sourceID && deepData[i].sourceID.length > 0) {
        // 动态源
        deepData[i].options = []
      }
    } else if (deepData[i].lineList) {
      // 表格组
      // 表格组在编辑的时候originalLine为null
      // 表格组在预览的时候lineList为null，originalLine有值
      formSubmitFormat(deepData[i].lineList[0].fieldList)
    } else {
      // 第一次
      if (deepData[i].sourceID && deepData[i].sourceID.length > 0) {
        // 动态源
        deepData[i].options = []
      }
      if (deepData[i].otherInput && deepData[i].hasOtherInput) {
        // 复选款、单选框、单级下拉选择了开启显示‘其他’输入框
        deepData[i].otherInput.isSelect = false
      }
    }
    deepData[i].isSelect = false
    if (deepData[i].fieldList && deepData[i].fieldList.length > 0) {
      formSubmitFormat(deepData[i].fieldList)
    }
  }
}
export const SUBMIT_FORM_HANDLE = function (data, formContentData = [], isStopType = 0, parentObj = null) {
  FORM_DATA_HANDLE.formDataMap(data, SUBMIT_FORM_OBJ, formContentData, isStopType, parentObj)
}
