/**
 * 元素控件枚举
 */
export const ELEMENT_TYPE_CODE = {
  text: 0,
  date: 1,
  select: 2,
  checkbox: 3,
  radio: 4
}
/**
 * 数据枚举 是元素还是标签
 */
export const DATA_TYPE = {
  label: '0',
  el: '1'
}

/**
 * 元素控件类型再EMREditor中的表示
 */
export const ELEMENT_EMR_TYPE = [
  { code: ELEMENT_TYPE_CODE.text, emrCode: 'text' },
  { code: ELEMENT_TYPE_CODE.date, emrCode: 'date' },
  { code: ELEMENT_TYPE_CODE.select, emrCode: 'select' },
  { code: ELEMENT_TYPE_CODE.checkbox, emrCode: 'checkboxs' },
  { code: ELEMENT_TYPE_CODE.radio, emrCode: 'radios' }
]

/**
 * 元素日期类型
 */
export const DATE_TYPE = {
  year: 'year',
  date: 'date',
  datetime: 'datetime',
  month: 'month'
}
/**
 * 元素日期格式
 */
export const DATE_FORMAT = {
  date: 'yyyy-MM-dd',
  year: 'yyyy',
  datetime: 'yyyy-MM-dd HH:mm:ss',
  month: 'yyyy-MM',
  customDate: 'yyyy-MM-dd HH:mm'
}

// 诊断排列方式常量
export const DIAGNOSIS_ORDER_CONST = {
  vertical: '1',
  horizontal: '2'
}

/**
 * 电子病历标签数据实体
 */
export const EL_CLASS_DATA = {
  // 分类代码
  classifyCode: '',
  // 分类层次
  classifyLevel: 0,
  // 分类名称
  classifyName: '',
  // 主键
  id: 0,
  // 组织机构代码
  orgNo: '',
  // 父级分类代码
  parentCode: '',
  // 创建人id
  createId: 0,
  // 创建人名称
  createName: '',
  // 创建人时间
  createTime: '',
  // 最近编辑号码
  recentEditorId: 0,
  // 最近编辑姓名
  recentEditorName: '',
  // 最近编辑时间
  recentEditorTime: '',
  // 最近编辑类别(逻辑 A:新增,M:修改,D:刪除)
  recentEditorType: '',
  // 子机构代码
  subNo: ''
}
/**
 * 临床数据源分类
 */
export const CLINICAL_DATA_SOURCE = [
  {
    value: 'T',
    name: '局部解剖学'
  },
  {
    value: 'M',
    name: '形态学'
  },
  {
    value: 'F',
    name: '功能'
  },
  {
    value: 'D',
    name: '疾病/诊断'
  },
  {
    value: 'P',
    name: '操作'
  },
  {
    value: 'L',
    name: '活有机体'
  },
  {
    value: 'C',
    name: '化学制品、药物和生物制品'
  },
  {
    value: 'A',
    name: '物理因素、活动和力'
  },
  {
    value: 'J',
    name: '职业'
  },
  {
    value: 'S',
    name: '社会环境'
  },
  {
    value: 'G',
    name: '关联词/修饰词'
  }
]
