// 使用人分类 1=医生 2=护士
export const USER_TYPE = {
  nurse: 2,
  doctor: 1
}
// 左边树结构查询条件对象实体
export const LEFTTREE_DATA = {
  // 'classifyCode': '', // 区分元素、章节及段落
  'deptCode': '', // 科室代码
  'keyWord': '', // 搜索关键字
  'scope': 1, // 使用范围(0-科室 1-全院 2-个人)
  'users': USER_TYPE.doctor
}
// 右边树结构查询条件对象实体
export const RIGHTTREE_DATA = {
  'classifyCode': 1, // 区分元素、章节及段落
  'deptCode': '', // 科室代码
  'keyWord': '', // 搜索关键字
  'scope': 1, // 使用范围(0-科室 1-全院 2-个人)
  'users': USER_TYPE.doctor
}
// 模板数据实体
export const TEMPLATE_DATA = {
  'id': '',
  'categoryCode': '',
  'templateCode': '',
  'templateName': '',
  'templateDescribe': '',
  'users': USER_TYPE.doctor,
  'templateContent': '',
  'createId': 0,
  'createName': '',
  'createTime': '',
  'scope': 1,
  'orgNo': null,
  'subNo': null,
  'recentEditorId': null,
  'recentEditorName': null,
  'recentEditorTime': null,
  'recentEditorType': null,
  // 'departmentCode': null,
  'departmentCode': [],
  'isDefault': false// 是否默认
}
// 章节分类
export const TEMPLATE_CLASSIFY = [{
  id: 1,
  label: '门诊病历模板'
},
{
  id: 2,
  label: '护士病历模板'
}]
// 模板分类数据实体
export const TEMPLATE_LABEL_CLASSIFY = {
  'categoryName': '',
  // 'users': USER_TYPE.doctor
  'parentCode': []
}
// 模板类型是分类还是模板
export const TEMPLATE_TYPE = {
  label: 1,
  template: 2
}
export const HADLE_TEMP_DATA = function(data) { // 如果最后一级没有children时删除该项否则最后是无数据
  data.forEach(item => {
    if (Object.prototype.toString.call(item.children) === '[object Array]') {
      if (item.children.length === 0) {
        delete item.children
      } else {
        return HADLE_TEMP_DATA(item.children)
      }
    }
  })
  return data
}
