// 用户中心相关函数
import store from '@/store'
import { SYSTEM_CODE, GET_URL_RATMS } from '@/utils/constants'

/**
 * 用户中心登录
 */
export const LOGIN_URL = process.env.VUE_APP_USER_URL + '/login'

/**
 * 用户中心系统列表
 */
export const SYSTEM_URL = process.env.VUE_APP_USER_URL
/**
 * 用户中心获取密保卡
 */
export const PWD_CARD = process.env.VUE_APP_USER_URL + '/card'
/**
 * 用户中心锁定屏幕
 */
export const LOCK_SCREEN = process.env.VUE_APP_USER_URL + '/lock'

/**
 * 跳转用户中心登录页面
 */
export const GOTO_LOGIN = function (isLayout) {
  localStorage.removeItem('token')
  let layoutType // 1是退出登陆
  if (!isLayout) {
    layoutType = 0
  } else {
    layoutType = 1
  }
  store.dispatch('removeAllInfo') // 清除所有患者信息的数据
  store.dispatch('doLogout') // 清除登陆时存储的用户数据
  let domain = window.location.href
  window.location.href = LOGIN_URL + '?return=' + encodeURI(domain) + '&system=' + SYSTEM_CODE + '&type=' + layoutType
}

const URL_SYS_CODE = 'titlecode'
/**
 * 监测当前系统是否合法, 成功获得system返回true，失败返回false（会跳转登录页面）
 * 大部分逻辑已经废除，目前一个网站只可能有一个系统，保险起见使用本地系统配置即可
 */
export const CK_SYSYEM = async function () {
  // 获取传入的系统code和本地缓存的code
  let urlTitleCode = GET_URL_RATMS(URL_SYS_CODE)
  let nowTitleCode = SYSTEM_CODE
  // console.log('CK_SYSYEM', urlTitleCode, nowTitleCode)
  if (urlTitleCode && nowTitleCode) {
    if (urlTitleCode === nowTitleCode) {
      // url传递了titleCode，且与本地相同，直接返回
      return true
    } else {
      // 与本地不同，则重设titleCode并判定系统权限
      // nowTitleCode = urlTitleCode
      return true
    }
  } else if (!urlTitleCode && nowTitleCode) {
    // url未传递titleCode，但是本地有，直接返回
    return true
  } else if (!urlTitleCode && !nowTitleCode) {
    // url未传递titleCode，本地也没有，则根据menu加载
    // 跳转登录页面
    GOTO_LOGIN()
    return false
  }
  // // 获取当前网站menuCode
  // let menu = SYSTEM_CODE
  // // 获取当前用户有权限的B/S的系统列表
  // let res = await getSystemApi({ titleType: 'B/S' })
  // if (res.data.code === 200 && res.data.data && res.data.data.length > 0) {
  //   this.systemList = res.data.data
  // } else {
  //   // 跳转登录页面
  //   GOTO_LOGIN()
  //   return false
  // }
  // let system = null
  // // 存在nowTitleCode时, 先判定是否拥有此系统权限
  // // 不存在nowTitleCode时，选择后台返回的系统列表中第一个menu相同的系统
  // if (nowTitleCode) {
  //   let hasSystem = this.systemList.findIndex(d => d.titleCode.toString() === nowTitleCode.toString())
  //   // 无此系统权限，则清除nowTitleCode
  //   if (hasSystem === -1) {
  //     nowTitleCode = null
  //   } else {
  //     system = this.systemList[hasSystem]
  //   }
  // }
  // // 系统无权限或没有，则查找一个
  // if (!nowTitleCode) {
  //   // 遍历所有系统，默认选择返回与来源系统menu相同的第一个system
  //   for (let item of this.systemList) {
  //     if (item.sysName === menu) {
  //       system = item
  //       break
  //     }
  //   }
  // }
  // // 如果找到的系统则进行设置
  // if (system) {
  //   store.dispatch('setSystem', system)
  // } else {
  //   // 如果没有找到系统，则直接跳转登录页面
  //   GOTO_LOGIN()
  //   return false
  // }
  // if (urlTitleCode) {
  //   // 替换当前url上的系统
  //   router.push({
  //     query: { URL_SYS_CODE: system.id }
  //   })
  // }
  // console.log('NOW_SYSYEM', system)
  // return true
}
